import java.util.ArrayList;

/**
 *
 * @author gsimon CLASSE A COMPLETER ! Classe permettant de gérer les
 *         déplacements d'un roi NB : Dans un premier temps, ne pas tenir compte
 *         du problème de mise en échec éventuelle
 */
public class Roi extends Piece {
    public Roi(String couleur){
        super(couleur);
    }

    @Override
    public boolean isRoi() {
        return true;
    }

    @Override
    public ArrayList<Case> getCasesPossibles(Echiquier ech) {

        /*
         * Par rapport aux autres pièces, ici il faudrait vérifier après avoir récupéré
         * lesdéplacements possibles qu'il n'y a pas de mise en échec (en utilisant
         * isEchec de Echiquier).
         */

        // on calcule les cases atteignables sans tenir compte des échecs
        ArrayList<Case> adp = getDepPossibles(ech);

        return adp;
    }

    public ArrayList<Case> getDepPossibles(Echiquier ech) {
        ArrayList<Case> adp = new ArrayList<Case>();

       for (int ligne = this.getL() - 1; ligne < this.getL() + 2; ligne++) {
            for (int colonne = this.getC() - 1; colonne < this.getC() + 2; colonne++) {
                    if (ligne != this.getL() 
                        || colonne != this.getC() 
                        && ech.caseExiste(ligne, colonne) 
                        && (null == ech.getPiece(ligne, colonne) 
                        || ech.getPiece(ligne, colonne).getCoul().equals(this.getCoul())) 
                        && !ech.isEchec(this.getCoul(), ligne, colonne)) {
                        adp.add(new Case(ligne, colonne));
                    }
            }
        }

        return adp;
    }

    @Override

    public String toString(){
                if(this.getCoul().equals("B")){
            return "RB";
        }

        return "RN";
    }
    

}
